/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.internet.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.internet.entity.InternetSeite;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractInternetSeiteSearch {

  @Inject
  protected transient InternetSeiteExtendedDAO dao;

  public AbstractInternetSeiteSearch() {
    super();
  }

  public List<InternetSeite> getSearchResult(InternetSeiteSearchParameters searchParameters, EagerLoadingCollector<InternetSeite> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<InternetSeite> querySearchResult(InternetSeiteSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
